/[gentoo-x86]/eclass/kde4-base.eclass
Gentoo

Diff of /eclass/kde4-base.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.93 Revision 1.157
1# Copyright 1999-2010 Gentoo Foundation 1# Copyright 1999-2015 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.93 2011/05/23 22:56:36 abcd Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.157 2015/07/01 11:28:23 mrueg Exp $
4 4
5# @ECLASS: kde4-base.eclass 5# @ECLASS: kde4-base.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: This eclass provides functions for kde 4.X ebuilds 8# @BLURB: This eclass provides functions for kde 4.X ebuilds
9# @DESCRIPTION: 9# @DESCRIPTION:
10# The kde4-base.eclass provides support for building KDE4 based ebuilds 10# The kde4-base.eclass provides support for building KDE4 based ebuilds
11# and KDE4 applications. 11# and KDE4 applications.
12# 12#
13# NOTE: KDE 4 ebuilds currently support EAPI "3". This will be reviewed 13# NOTE: KDE 4 ebuilds currently support EAPI 5. This will be
14# over time as new EAPI versions are approved. 14# reviewed over time as new EAPI versions are approved.
15
16if [[ -z ${_KDE4_BASE_ECLASS} ]]; then
17_KDE4_BASE_ECLASS=1
18
19# @ECLASS-VARIABLE: KDE_SELINUX_MODULE
20# @DESCRIPTION:
21# If set to "none", do nothing.
22# For any other value, add selinux to IUSE, and depending on that useflag
23# add a dependency on sec-policy/selinux-${KDE_SELINUX_MODULE} to (R)DEPEND
24: ${KDE_SELINUX_MODULE:=none}
25
26# @ECLASS-VARIABLE: VIRTUALDBUS_TEST
27# @DESCRIPTION:
28# If defined, launch and use a private dbus session during src_test.
15 29
16# @ECLASS-VARIABLE: VIRTUALX_REQUIRED 30# @ECLASS-VARIABLE: VIRTUALX_REQUIRED
17# @DESCRIPTION: 31# @DESCRIPTION:
18# For proper description see virtualx.eclass manpage. 32# For proper description see virtualx.eclass manpage.
19# Here we redefine default value to be manual, if your package needs virtualx 33# Here we redefine default value to be manual, if your package needs virtualx
20# for tests you should proceed with setting VIRTUALX_REQUIRED=test. 34# for tests you should proceed with setting VIRTUALX_REQUIRED=test.
21: ${VIRTUALX_REQUIRED:=manual} 35: ${VIRTUALX_REQUIRED:=manual}
22 36
23inherit kde4-functions toolchain-funcs fdo-mime gnome2-utils base virtualx versionator eutils 37inherit kde4-functions toolchain-funcs fdo-mime flag-o-matic gnome2-utils virtualx versionator eutils multilib
24 38
25if [[ ${BUILD_TYPE} = live ]]; then 39if [[ ${KDE_BUILD_TYPE} = live ]]; then
26 case ${KDE_SCM} in 40 case ${KDE_SCM} in
27 svn) inherit subversion ;; 41 svn) inherit subversion ;;
28 git) inherit git-2 ;; 42 git) inherit git-r3 ;;
29 esac 43 esac
30fi 44fi
31 45
32# @ECLASS-VARIABLE: CMAKE_REQUIRED 46# @ECLASS-VARIABLE: CMAKE_REQUIRED
33# @DESCRIPTION: 47# @DESCRIPTION:
39if [[ ${CMAKE_REQUIRED} = always ]]; then 53if [[ ${CMAKE_REQUIRED} = always ]]; then
40 buildsystem_eclass="cmake-utils" 54 buildsystem_eclass="cmake-utils"
41 export_fns="src_configure src_compile src_test src_install" 55 export_fns="src_configure src_compile src_test src_install"
42fi 56fi
43 57
44# Verify KDE_MINIMAL (display QA notice in pkg_setup, still we need to fix it here)
45if [[ -n ${KDE_MINIMAL} ]]; then
46 for slot in ${KDE_SLOTS[@]} ${KDE_LIVE_SLOTS[@]}; do
47 [[ ${KDE_MINIMAL} = ${slot} ]] && KDE_MINIMAL_VALID=1 && break
48 done
49 unset slot
50 [[ -z ${KDE_MINIMAL_VALID} ]] && unset KDE_MINIMAL
51else
52 KDE_MINIMAL_VALID=1
53fi
54
55# @ECLASS-VARIABLE: KDE_MINIMAL 58# @ECLASS-VARIABLE: KDE_MINIMAL
56# @DESCRIPTION: 59# @DESCRIPTION:
57# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal 60# This variable is used when KDE_REQUIRED is set, to specify required KDE minimal
58# version for apps to work. Currently defaults to 4.4 61# version for apps to work. Currently defaults to 4.4
59# One may override this variable to raise version requirements. 62# One may override this variable to raise version requirements.
60# For possible values look at KDE_SLOTS and KDE_LIVE_SLOTS variables.
61# Note that it is fixed to ${SLOT} for kde-base packages. 63# Note that it is fixed to ${PV} for kde-base packages.
62KDE_MINIMAL="${KDE_MINIMAL:-4.4}" 64KDE_MINIMAL="${KDE_MINIMAL:-4.4}"
63 65
64# Set slot for KDEBASE known packages 66# Set slot for KDEBASE known packages
65case ${KDEBASE} in 67case ${KDEBASE} in
66 kde-base) 68 kde-base)
67 SLOT=$(_calculate_kde_slot) 69 SLOT=4/$(get_version_component_range 1-2)
68 [[ -z ${SLOT} ]] && die "Unsupported ${PV}"
69 KDE_MINIMAL="${SLOT}" 70 KDE_MINIMAL="${PV}"
70 ;;
71 koffice)
72 SLOT="2"
73 ;; 71 ;;
74 kdevelop) 72 kdevelop)
75 if [[ ${BUILD_TYPE} = live ]]; then 73 if [[ ${KDE_BUILD_TYPE} = live ]]; then
76 # @ECLASS-VARIABLE: KDEVELOP_VERSION 74 # @ECLASS-VARIABLE: KDEVELOP_VERSION
77 # @DESCRIPTION: 75 # @DESCRIPTION:
78 # Specifies KDevelop version. Default is 4.0.0 for tagged packages and 9999 for live packages. 76 # Specifies KDevelop version. Default is 4.0.0 for tagged packages and 9999 for live packages.
79 # Applies to KDEBASE=kdevelop only. 77 # Applies to KDEBASE=kdevelop only.
80 KDEVELOP_VERSION="${KDEVELOP_VERSION:-9999}" 78 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.9999}"
81 # @ECLASS-VARIABLE: KDEVPLATFORM_VERSION 79 # @ECLASS-VARIABLE: KDEVPLATFORM_VERSION
82 # @DESCRIPTION: 80 # @DESCRIPTION:
83 # Specifies KDevplatform version. Default is 1.0.0 for tagged packages and 9999 for live packages. 81 # Specifies KDevplatform version. Default is 1.0.0 for tagged packages and 9999 for live packages.
84 # Applies to KDEBASE=kdevelop only. 82 # Applies to KDEBASE=kdevelop only.
85 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-9999}" 83 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-4.9999}"
86 else 84 else
87 case ${PN} in 85 case ${PN} in
88 kdevelop|quanta) 86 kdevelop)
89 KDEVELOP_VERSION=${PV} 87 KDEVELOP_VERSION=${PV}
90 KDEVPLATFORM_VERSION="$(($(get_major_version)-3)).$(get_after_major_version)" 88 KDEVPLATFORM_VERSION="$(($(get_major_version)-3)).$(get_after_major_version)"
91 ;; 89 ;;
92 kdevplatform) 90 kdevplatform|kdevelop-php*|kdevelop-python)
93 KDEVELOP_VERSION="$(($(get_major_version)+3)).$(get_after_major_version)" 91 KDEVELOP_VERSION="$(($(get_major_version)+3)).$(get_after_major_version)"
94 KDEVPLATFORM_VERSION=${PV} 92 KDEVPLATFORM_VERSION=${PV}
95 ;; 93 ;;
96 *) 94 *)
97 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.0.0}" 95 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.0.0}"
109unset buildsystem_eclass 107unset buildsystem_eclass
110unset export_fns 108unset export_fns
111 109
112# @ECLASS-VARIABLE: DECLARATIVE_REQUIRED 110# @ECLASS-VARIABLE: DECLARATIVE_REQUIRED
113# @DESCRIPTION: 111# @DESCRIPTION:
114# Is qt-declarative required? Possible values are 'always', 'optional' and 'never'. 112# Is qtdeclarative required? Possible values are 'always', 'optional' and 'never'.
115# This variable must be set before inheriting any eclasses. Defaults to 'never'. 113# This variable must be set before inheriting any eclasses. Defaults to 'never'.
116DECLARATIVE_REQUIRED="${DECLARATIVE_REQUIRED:-never}" 114DECLARATIVE_REQUIRED="${DECLARATIVE_REQUIRED:-never}"
117 115
118# @ECLASS-VARIABLE: QTHELP_REQUIRED 116# @ECLASS-VARIABLE: QTHELP_REQUIRED
119# @DESCRIPTION: 117# @DESCRIPTION:
120# Is qt-assistant required? Possible values are 'always', 'optional' and 'never'. 118# Is qthelp required? Possible values are 'always', 'optional' and 'never'.
121# This variable must be set before inheriting any eclasses. Defaults to 'never'. 119# This variable must be set before inheriting any eclasses. Defaults to 'never'.
122QTHELP_REQUIRED="${QTHELP_REQUIRED:-never}" 120QTHELP_REQUIRED="${QTHELP_REQUIRED:-never}"
123 121
124# @ECLASS-VARIABLE: OPENGL_REQUIRED 122# @ECLASS-VARIABLE: OPENGL_REQUIRED
125# @DESCRIPTION: 123# @DESCRIPTION:
126# Is qt-opengl required? Possible values are 'always', 'optional' and 'never'. 124# Is qtopengl required? Possible values are 'always', 'optional' and 'never'.
127# This variable must be set before inheriting any eclasses. Defaults to 'never'. 125# This variable must be set before inheriting any eclasses. Defaults to 'never'.
128OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}" 126OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}"
129 127
130# @ECLASS-VARIABLE: MULTIMEDIA_REQUIRED 128# @ECLASS-VARIABLE: MULTIMEDIA_REQUIRED
131# @DESCRIPTION: 129# @DESCRIPTION:
132# Is qt-multimedia required? Possible values are 'always', 'optional' and 'never'. 130# Is qtmultimedia required? Possible values are 'always', 'optional' and 'never'.
133# This variable must be set before inheriting any eclasses. Defaults to 'never'. 131# This variable must be set before inheriting any eclasses. Defaults to 'never'.
134MULTIMEDIA_REQUIRED="${MULTIMEDIA_REQUIRED:-never}" 132MULTIMEDIA_REQUIRED="${MULTIMEDIA_REQUIRED:-never}"
135
136# @ECLASS-VARIABLE: WEBKIT_REQUIRED
137# @DESCRIPTION:
138# Is qt-webkit requred? Possible values are 'always', 'optional' and 'never'.
139# This variable must be set before inheriting any eclasses. Defaults to 'never'.
140WEBKIT_REQUIRED="${WEBKIT_REQUIRED:-never}"
141 133
142# @ECLASS-VARIABLE: CPPUNIT_REQUIRED 134# @ECLASS-VARIABLE: CPPUNIT_REQUIRED
143# @DESCRIPTION: 135# @DESCRIPTION:
144# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'. 136# Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'.
145# This variable must be set before inheriting any eclasses. Defaults to 'never'. 137# This variable must be set before inheriting any eclasses. Defaults to 'never'.
165# @ECLASS-VARIABLE: KDE_LINGUAS_LIVE_OVERRIDE 157# @ECLASS-VARIABLE: KDE_LINGUAS_LIVE_OVERRIDE
166# @DESCRIPTION: 158# @DESCRIPTION:
167# Set this varible if you want your live package to manage its 159# Set this varible if you want your live package to manage its
168# translations. (Mostly all kde ebuilds does not ship documentation 160# translations. (Mostly all kde ebuilds does not ship documentation
169# and translations in live ebuilds) 161# and translations in live ebuilds)
170if [[ ${BUILD_TYPE} == live && -z ${KDE_LINGUAS_LIVE_OVERRIDE} ]]; then 162if [[ ${KDE_BUILD_TYPE} == live && -z ${KDE_LINGUAS_LIVE_OVERRIDE} ]]; then
171 # Kdebase actualy provides the handbooks even for live stuff 163 # Kdebase actualy provides the handbooks even for live stuff
172 [[ ${KDEBASE} == kde-base ]] || KDE_HANDBOOK=never 164 [[ ${KDEBASE} == kde-base ]] || KDE_HANDBOOK=never
173 KDE_LINGUAS="" 165 KDE_LINGUAS=""
174fi 166fi
175 167
176# Setup packages inheriting this eclass 168# Setup packages inheriting this eclass
177case ${KDEBASE} in 169case ${KDEBASE} in
178 kde-base) 170 kde-base)
179 HOMEPAGE="http://www.kde.org/" 171 HOMEPAGE="http://www.kde.org/"
180 LICENSE="GPL-2" 172 LICENSE="GPL-2"
181 if [[ $BUILD_TYPE = live ]]; then 173 if [[ ${KDE_BUILD_TYPE} = live && -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
182 # Disable tests for live ebuilds 174 # Disable tests for live ebuilds by default
183 RESTRICT+=" test" 175 RESTRICT+=" test"
184 # Live ebuilds in kde-base default to kdeprefix by default
185 IUSE+=" +kdeprefix"
186 else
187 # All other ebuild types default to -kdeprefix as before
188 IUSE+=" kdeprefix"
189 fi 176 fi
177
190 # This code is to prevent portage from searching GENTOO_MIRRORS for 178 # This code is to prevent portage from searching GENTOO_MIRRORS for
191 # packages that will never be mirrored. (As they only will ever be in 179 # packages that will never be mirrored. (As they only will ever be in
192 # the overlay). 180 # the overlay).
193 case ${PV} in 181 case ${PV} in
194 *9999* | 4.?.[6-9]?) 182 *9999* | 4.?.[6-9]? | 4.??.[6-9]? | ??.?.[6-9]? | ??.??.[6-9]?)
195 RESTRICT+=" mirror" 183 RESTRICT+=" mirror"
196 ;; 184 ;;
197 esac 185 esac
198 # Block installation of other SLOTS unless kdeprefix
199 RDEPEND+=" $(block_other_slots)"
200 ;;
201 koffice)
202 HOMEPAGE="http://www.koffice.org/"
203 LICENSE="GPL-2"
204 ;; 186 ;;
205 kdevelop) 187 kdevelop)
206 HOMEPAGE="http://www.kdevelop.org/" 188 HOMEPAGE="http://www.kdevelop.org/"
207 LICENSE="GPL-2" 189 LICENSE="GPL-2"
208 ;; 190 ;;
209esac 191esac
210 192
211# @ECLASS-VARIABLE: QT_MINIMAL 193# @ECLASS-VARIABLE: QT_MINIMAL
212# @DESCRIPTION: 194# @DESCRIPTION:
213# Determine version of qt we enforce as minimal for the package. 195# Determine version of qt we enforce as minimal for the package.
214if slot_is_at_least 4.6 "${KDE_MINIMAL}"; then
215 QT_MINIMAL="${QT_MINIMAL:-4.7.0}" 196QT_MINIMAL="${QT_MINIMAL:-4.8.5}"
216else
217 QT_MINIMAL="${QT_MINIMAL:-4.6.3}"
218fi
219 197
220# Declarative dependencies 198# Declarative dependencies
221qtdeclarativedepend=" 199qtdeclarativedepend="
222 >=x11-libs/qt-declarative-${QT_MINIMAL}:4 200 >=dev-qt/qtdeclarative-${QT_MINIMAL}:4
223" 201"
224case ${DECLARATIVE_REQUIRED} in 202case ${DECLARATIVE_REQUIRED} in
225 always) 203 always)
226 COMMONDEPEND+=" ${qtdeclarativedepend}" 204 COMMONDEPEND+=" ${qtdeclarativedepend}"
227 ;; 205 ;;
233esac 211esac
234unset qtdeclarativedepend 212unset qtdeclarativedepend
235 213
236# QtHelp dependencies 214# QtHelp dependencies
237qthelpdepend=" 215qthelpdepend="
238 >=x11-libs/qt-assistant-${QT_MINIMAL}:4 216 >=dev-qt/qthelp-${QT_MINIMAL}:4
239" 217"
240case ${QTHELP_REQUIRED} in 218case ${QTHELP_REQUIRED} in
241 always) 219 always)
242 COMMONDEPEND+=" ${qthelpdepend}" 220 COMMONDEPEND+=" ${qthelpdepend}"
243 ;; 221 ;;
248esac 226esac
249unset qthelpdepend 227unset qthelpdepend
250 228
251# OpenGL dependencies 229# OpenGL dependencies
252qtopengldepend=" 230qtopengldepend="
253 >=x11-libs/qt-opengl-${QT_MINIMAL}:4 231 >=dev-qt/qtopengl-${QT_MINIMAL}:4
254" 232"
255case ${OPENGL_REQUIRED} in 233case ${OPENGL_REQUIRED} in
256 always) 234 always)
257 COMMONDEPEND+=" ${qtopengldepend}" 235 COMMONDEPEND+=" ${qtopengldepend}"
258 ;; 236 ;;
264esac 242esac
265unset qtopengldepend 243unset qtopengldepend
266 244
267# MultiMedia dependencies 245# MultiMedia dependencies
268qtmultimediadepend=" 246qtmultimediadepend="
269 >=x11-libs/qt-multimedia-${QT_MINIMAL}:4 247 >=dev-qt/qtmultimedia-${QT_MINIMAL}:4
270" 248"
271case ${MULTIMEDIA_REQUIRED} in 249case ${MULTIMEDIA_REQUIRED} in
272 always) 250 always)
273 COMMONDEPEND+=" ${qtmultimediadepend}" 251 COMMONDEPEND+=" ${qtmultimediadepend}"
274 ;; 252 ;;
277 COMMONDEPEND+=" multimedia? ( ${qtmultimediadepend} )" 255 COMMONDEPEND+=" multimedia? ( ${qtmultimediadepend} )"
278 ;; 256 ;;
279 *) ;; 257 *) ;;
280esac 258esac
281unset qtmultimediadepend 259unset qtmultimediadepend
282
283# WebKit dependencies
284case ${KDE_REQUIRED} in
285 always)
286 qtwebkitusedeps="[kde]"
287 ;;
288 optional)
289 qtwebkitusedeps="[kde?]"
290 ;;
291 *) ;;
292esac
293qtwebkitdepend="
294 >=x11-libs/qt-webkit-${QT_MINIMAL}:4${qtwebkitusedeps}
295"
296unset qtwebkitusedeps
297case ${WEBKIT_REQUIRED} in
298 always)
299 COMMONDEPEND+=" ${qtwebkitdepend}"
300 ;;
301 optional)
302 IUSE+=" webkit"
303 COMMONDEPEND+=" webkit? ( ${qtwebkitdepend} )"
304 ;;
305 *) ;;
306esac
307unset qtwebkitdepend
308 260
309# CppUnit dependencies 261# CppUnit dependencies
310cppuintdepend=" 262cppuintdepend="
311 dev-util/cppunit 263 dev-util/cppunit
312" 264"
324 276
325# KDE dependencies 277# KDE dependencies
326# Qt accessibility classes are needed in various places, bug 325461 278# Qt accessibility classes are needed in various places, bug 325461
327kdecommondepend=" 279kdecommondepend="
328 dev-lang/perl 280 dev-lang/perl
281 >=dev-qt/qt3support-${QT_MINIMAL}:4[accessibility]
329 >=x11-libs/qt-core-${QT_MINIMAL}:4[qt3support,ssl] 282 >=dev-qt/qtcore-${QT_MINIMAL}:4[qt3support,ssl]
283 >=dev-qt/qtdbus-${QT_MINIMAL}:4
284 >=dev-qt/designer-${QT_MINIMAL}:4
330 >=x11-libs/qt-gui-${QT_MINIMAL}:4[accessibility,dbus] 285 >=dev-qt/qtgui-${QT_MINIMAL}:4[accessibility,dbus(+)]
331 >=x11-libs/qt-qt3support-${QT_MINIMAL}:4[accessibility,kde]
332 >=x11-libs/qt-script-${QT_MINIMAL}:4 286 >=dev-qt/qtscript-${QT_MINIMAL}:4
333 >=x11-libs/qt-sql-${QT_MINIMAL}:4[qt3support] 287 >=dev-qt/qtsql-${QT_MINIMAL}:4[qt3support]
334 >=x11-libs/qt-svg-${QT_MINIMAL}:4 288 >=dev-qt/qtsvg-${QT_MINIMAL}:4
335 >=x11-libs/qt-test-${QT_MINIMAL}:4 289 >=dev-qt/qttest-${QT_MINIMAL}:4
336 !aqua? ( 290 >=dev-qt/qtwebkit-${QT_MINIMAL}:4
337 x11-libs/libXext
338 x11-libs/libXt
339 x11-libs/libXxf86vm
340 x11-libs/libXcomposite
341 )
342" 291"
343 292
344if [[ ${PN} != kdelibs ]]; then 293if [[ ${PN} != kdelibs ]]; then
345 kdecommondepend+=" $(add_kdebase_dep kdelibs)" 294 kdecommondepend+=" $(add_kdebase_dep kdelibs)"
346 if [[ ${KDEBASE} = kdevelop ]]; then 295 if [[ ${KDEBASE} = kdevelop ]]; then
351 # Applies to KDEBASE=kdevelop only. 300 # Applies to KDEBASE=kdevelop only.
352 KDEVPLATFORM_REQUIRED="${KDEVPLATFORM_REQUIRED:-always}" 301 KDEVPLATFORM_REQUIRED="${KDEVPLATFORM_REQUIRED:-always}"
353 case ${KDEVPLATFORM_REQUIRED} in 302 case ${KDEVPLATFORM_REQUIRED} in
354 always) 303 always)
355 kdecommondepend+=" 304 kdecommondepend+="
356 >=dev-util/kdevplatform-${KDEVPLATFORM_VERSION} 305 >=dev-util/kdevplatform-${KDEVPLATFORM_VERSION}:4
357 " 306 "
358 ;; 307 ;;
359 *) ;; 308 *) ;;
360 esac 309 esac
361 fi 310 fi
362 fi 311 fi
363fi 312fi
364 313
365kdedepend=" 314kdedepend="
366 dev-util/automoc 315 dev-util/automoc
367 dev-util/pkgconfig 316 virtual/pkgconfig
368 !aqua? ( 317 !aqua? (
369 >=x11-libs/libXtst-1.1.0 318 >=x11-libs/libXtst-1.1.0
370 x11-proto/xf86vidmodeproto 319 x11-proto/xf86vidmodeproto
371 ) 320 )
372" 321"
373 322
374kderdepend="" 323kderdepend=""
375 324
325if [[ ${CATEGORY} == kde-apps ]]; then
326 kderdepend+=" !kde-base/${PN}"
327fi
328
376# all packages needs oxygen icons for basic iconset 329# all packages needs oxygen icons for basic iconset
377if [[ ${PN} != oxygen-icons ]]; then 330if [[ ${PN} != oxygen-icons ]]; then
378 kderdepend+=" $(add_kdebase_dep oxygen-icons)" 331 kderdepend+=" kde-apps/oxygen-icons"
379fi 332fi
380 333
381# add a dependency over kde-l10n if EAPI4 or better is around 334# add a dependency over kde-l10n
382if [[ ${KDEBASE} != "kde-base" && -n ${KDE_LINGUAS} && ${EAPI:-0} != 3 ]]; then 335if [[ ${KDEBASE} != "kde-base" && -n ${KDE_LINGUAS} ]]; then
383 for _lingua in ${KDE_LINGUAS}; do 336 for _lingua in ${KDE_LINGUAS}; do
384 # if our package has lignuas, pull in kde-l10n with selected lingua enabled, 337 # if our package has linguas, pull in kde-l10n with selected lingua enabled,
385 # but only for selected ones. 338 # but only for selected ones.
386 # this can't be done on one line because if user doesn't use any localisation 339 # this can't be done on one line because if user doesn't use any localisation
387 # then he is probably not interested in kde-l10n at all. 340 # then he is probably not interested in kde-l10n at all.
388 kderdepend+=" 341 kderdepend+="
389 linguas_${_lingua}? ( $(add_kdebase_dep kde-l10n "linguas_${_lingua}(+)") ) 342 linguas_${_lingua}? ( $(add_kdeapps_dep kde4-l10n "linguas_${_lingua}(+)") )
390 " 343 "
391 done 344 done
392 unset _lingua 345 unset _lingua
393fi 346fi
394 347
411 ;; 364 ;;
412 *) ;; 365 *) ;;
413esac 366esac
414unset kdehandbookdepend kdehandbookrdepend 367unset kdehandbookdepend kdehandbookrdepend
415 368
369case ${KDE_SELINUX_MODULE} in
370 none) ;;
371 *)
372 IUSE+=" selinux"
373 kderdepend+=" selinux? ( sec-policy/selinux-${KDE_SELINUX_MODULE} )"
374 ;;
375esac
376
377# We always need the aqua useflag because otherwise we cannot = refer to it inside
378# add_kdebase_dep. This was always kind of a bug, but came to light with EAPI=5
379# (where referring to a use flag not in IUSE masks the ebuild).
380# The only alternative would be to prohibit using add_kdebase_dep if KDE_REQUIRED=never
381IUSE+=" aqua"
382
416case ${KDE_REQUIRED} in 383case ${KDE_REQUIRED} in
417 always) 384 always)
418 IUSE+=" aqua"
419 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" ${kdecommondepend}" 385 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" ${kdecommondepend}"
420 [[ -n ${kdedepend} ]] && DEPEND+=" ${kdedepend}" 386 [[ -n ${kdedepend} ]] && DEPEND+=" ${kdedepend}"
421 [[ -n ${kderdepend} ]] && RDEPEND+=" ${kderdepend}" 387 [[ -n ${kderdepend} ]] && RDEPEND+=" ${kderdepend}"
422 ;; 388 ;;
423 optional) 389 optional)
424 IUSE+=" aqua kde" 390 IUSE+=" kde"
425 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" kde? ( ${kdecommondepend} )" 391 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" kde? ( ${kdecommondepend} )"
426 [[ -n ${kdedepend} ]] && DEPEND+=" kde? ( ${kdedepend} )" 392 [[ -n ${kdedepend} ]] && DEPEND+=" kde? ( ${kdedepend} )"
427 [[ -n ${kderdepend} ]] && RDEPEND+=" kde? ( ${kderdepend} )" 393 [[ -n ${kderdepend} ]] && RDEPEND+=" kde? ( ${kderdepend} )"
428 ;; 394 ;;
429 *) ;; 395 *) ;;
438# Accumulate dependencies set by this eclass 404# Accumulate dependencies set by this eclass
439DEPEND+=" ${COMMONDEPEND}" 405DEPEND+=" ${COMMONDEPEND}"
440RDEPEND+=" ${COMMONDEPEND}" 406RDEPEND+=" ${COMMONDEPEND}"
441unset COMMONDEPEND 407unset COMMONDEPEND
442 408
443# Add experimental kdeenablefinal, masked by default
444IUSE+=" kdeenablefinal"
445
446# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a 409# Fetch section - If the ebuild's category is not 'kde-base' and if it is not a
447# koffice ebuild, the URI should be set in the ebuild itself 410# kdevelop ebuild, the URI should be set in the ebuild itself
448_calculate_src_uri() { 411_calculate_src_uri() {
449 debug-print-function ${FUNCNAME} "$@" 412 debug-print-function ${FUNCNAME} "$@"
450 413
451 local _kmname _kmname_pv 414 local _kmname _kmname_pv
452 415
453 # we calculate URI only for known KDEBASE modules 416 # we calculate URI only for known KDEBASE modules
454 [[ -n ${KDEBASE} ]] || return 417 [[ -n ${KDEBASE} ]] || return
455 418
456 # calculate tarball module name 419 # calculate tarball module name
457 if [[ -n ${KMNAME} ]]; then 420 if [[ -n ${KMNAME} ]]; then
458 # fixup kdebase-apps name
459 case ${KMNAME} in
460 kdebase-apps)
461 _kmname="kdebase" ;;
462 *)
463 _kmname="${KMNAME}" ;; 421 _kmname="${KMNAME}"
464 esac
465 else 422 else
466 _kmname=${PN} 423 _kmname=${PN}
467 fi 424 fi
468 _kmname_pv="${_kmname}-${PV}" 425 _kmname_pv="${_kmname}-${PV}"
469 case ${KDEBASE} in 426 case ${KDEBASE} in
470 kde-base) 427 kde-base)
471 case ${PV} in 428 case ${PV} in
472 4.[456].8[05] | 4.[456].9[023568]) 429 4.4.11.1)
430 # KDEPIM 4.4, special case
431 # TODO: Remove this part when KDEPIM 4.4 gets out of the tree
432 SRC_URI="mirror://kde/stable/kdepim-${PV}/src/${_kmname_pv}.tar.bz2" ;;
433 4.4.20*)
434 # KDEPIM 4.4 no-akonadi branch, special case
435 # TODO: Remove this part when KDEPIM 4.4 gets out of the tree
436 SRC_URI="http://dev.gentoo.org/~dilfridge/distfiles/${_kmname_pv}.tar.xz" ;;
437 4.?.[6-9]? | 4.??.[6-9]?)
473 # Unstable KDE SC releases 438 # Unstable KDE SC releases
474 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.bz2" 439 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.xz" ;;
475 # KDEPIM IS SPECIAL 440 4.11.14)
476 [[ ${KMNAME} == "kdepim" || ${KMNAME} == "kdepim-runtime" ]] && SRC_URI="mirror://kde/unstable/kdepim/${PV}/${_kmname_pv}.tar.bz2" 441 # Part of 4.14 actually, sigh. Not stable for next release!
477 ;; 442 SRC_URI="mirror://kde/stable/4.14.3/src/${_kmname_pv}.tar.xz" ;;
478 4.4.[6789] | 4.4.1?*) 443 4.11.17)
479 # Stable kdepim releases 444 # Part of 14.12.3 actually, sigh. Not stable for next release!
445 SRC_URI="mirror://kde/stable/applications/14.12.3/src/${_kmname_pv}.tar.xz" ;;
446 4.11.18)
447 # Part of 15.04.0 actually, sigh. Not stable for next release!
448 SRC_URI="mirror://kde/stable/applications/15.04.0/src/${_kmname_pv}.tar.xz" ;;
449 4.11.19)
450 # Part of 15.04.1 actually, sigh. Not stable for next release!
451 SRC_URI="mirror://kde/stable/applications/15.04.1/src/${_kmname_pv}.tar.xz" ;;
452 4.11.20)
453 # Part of 15.04.2 actually, sigh. Not stable for next release!
454 SRC_URI="mirror://kde/stable/applications/15.04.2/src/${_kmname_pv}.tar.xz" ;;
455 4.11.21)
456 # Part of 15.04.3 actually, sigh. Not stable for next release!
457 SRC_URI="mirror://kde/stable/applications/15.04.3/src/${_kmname_pv}.tar.xz" ;;
458 4.14.3)
459 # Last SC release
480 SRC_URI="mirror://kde/stable/kdepim-${PV}/src/${_kmname_pv}.tar.bz2" 460 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.xz" ;;
481 ;; 461 4.14.6)
462 # Part of 14.12.3 actually, sigh. Not stable for next release!
463 SRC_URI="mirror://kde/stable/applications/14.12.3/src/${_kmname_pv}.tar.xz" ;;
464 4.14.7)
465 # Part of 15.04.0 actually, sigh. Not stable for next release!
466 SRC_URI="mirror://kde/stable/applications/15.04.0/src/${_kmname_pv}.tar.xz" ;;
467 4.14.8)
468 # Part of 15.04.1 actually, sigh. Not stable for next release!
469 SRC_URI="mirror://kde/stable/applications/15.04.1/src/${_kmname_pv}.tar.xz" ;;
470 4.14.9)
471 # Part of 15.04.2 actually, sigh. Not stable for next release!
472 SRC_URI="mirror://kde/stable/applications/15.04.2/src/${_kmname_pv}.tar.xz" ;;
473 4.14.10)
474 # Part of 15.04.3 actually, sigh. Not stable for next release!
475 SRC_URI="mirror://kde/stable/applications/15.04.3/src/${_kmname_pv}.tar.xz" ;;
476 ??.?.[6-9]? | ??.??.[4-9]?)
477 # Unstable KDE Applications releases
478 SRC_URI="mirror://kde/unstable/applications/${PV}/src/${_kmname}-${PV}.tar.xz" ;;
482 *) 479 *)
483 # Stable KDE SC releases 480 # Stable KDE Applications releases
484 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2" 481 SRC_URI="mirror://kde/stable/applications/${PV}/src/${_kmname}-${PV}.tar.xz"
485 ;; 482 ;;
486 esac 483 esac
487 ;; 484 ;;
488 koffice) 485 kdevelop|kdevelop-php*|kdevplatform)
489 case ${PV} in 486 case ${KDEVELOP_VERSION} in
490 2.[1234].[6-9]*) SRC_URI="mirror://kde/unstable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;; 487 4.[123].[6-9]*) SRC_URI="mirror://kde/unstable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.xz" ;;
491 *) SRC_URI="mirror://kde/stable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;; 488 *) SRC_URI="mirror://kde/stable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.xz" ;;
492 esac 489 esac
493 ;;
494 kdevelop)
495 SRC_URI="mirror://kde/stable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2"
496 ;; 490 ;;
497 esac 491 esac
498} 492}
499 493
500_calculate_live_repo() { 494_calculate_live_repo() {
510 # trunk 504 # trunk
511 branch_prefix="trunk/KDE" 505 branch_prefix="trunk/KDE"
512 ;; 506 ;;
513 *) 507 *)
514 # branch 508 # branch
515 branch_prefix="branches/KDE/${SLOT}" 509 branch_prefix="branches/KDE/$(get_kde_version)"
516 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX 510 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX
517 # @DESCRIPTION 511 # @DESCRIPTION
518 # Suffix appended to ESVN_PROJECT depending on fetched branch. 512 # Suffix appended to ESVN_PROJECT depending on fetched branch.
519 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise. 513 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise.
520 ESVN_PROJECT_SUFFIX="-${PV}" 514 ESVN_PROJECT_SUFFIX="-${PV}"
553 # Unpack them in toplevel dir, so that they won't conflict with kde4-meta 547 # Unpack them in toplevel dir, so that they won't conflict with kde4-meta
554 # build packages from same svn location. 548 # build packages from same svn location.
555 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}" 549 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
556 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}" 550 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
557 ;; 551 ;;
558 koffice)
559 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
560 ;;
561 *) 552 *)
562 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}" 553 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
563 ;; 554 ;;
564 esac 555 esac
565 else 556 else
568 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}" 559 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
569 fi 560 fi
570 # @ECLASS-VARIABLE: ESVN_UP_FREQ 561 # @ECLASS-VARIABLE: ESVN_UP_FREQ
571 # @DESCRIPTION: 562 # @DESCRIPTION:
572 # This variable is used for specifying the timeout between svn synces 563 # This variable is used for specifying the timeout between svn synces
573 # for kde-base and koffice modules. Does not affect misc apps. 564 # for kde-base modules. Does not affect misc apps.
574 # Default value is 1 hour. 565 # Default value is 1 hour.
575 [[ ${KDEBASE} = kde-base || ${KDEBASE} = koffice ]] && ESVN_UP_FREQ=${ESVN_UP_FREQ:-1} 566 [[ ${KDEBASE} = kde-base ]] && ESVN_UP_FREQ=${ESVN_UP_FREQ:-1}
576 ;; 567 ;;
577 git) 568 git)
578 local _kmname 569 local _kmname
579 # @ECLASS-VARIABLE: EGIT_MIRROR 570 # @ECLASS-VARIABLE: EGIT_MIRROR
580 # @DESCRIPTION: 571 # @DESCRIPTION:
594 else 585 else
595 _kmname=${PN} 586 _kmname=${PN}
596 fi 587 fi
597 588
598 # default branching 589 # default branching
599 case ${PV} in 590 [[ ${PV} != 4.9999* && ${PV} != 9999 && ${KDEBASE} == kde-base ]] && \
600 9999*) ;; 591 EGIT_BRANCH="KDE/$(get_kde_version)"
601 *)
602 # set EGIT_BRANCH and EGIT_COMMIT to ${SLOT}
603 case ${_kmname} in
604 kdeplasma-addons | kdepim | kdepim-runtime | kdepimlibs)
605 EGIT_BRANCH="${SLOT}"
606 ;;
607 *) EGIT_BRANCH="KDE/${SLOT}" ;;
608 esac
609 ;;
610 esac
611 592
593 # Applications branching
594 [[ ${PV} == ??.??.49.9999 && ${KDEBASE} == kde-base ]] && \
595 EGIT_BRANCH="Applications/$(get_kde_version)"
596
597 # default repo uri
612 EGIT_REPO_URI="${EGIT_MIRROR}/${_kmname}" 598 EGIT_REPO_URI+=( "${EGIT_MIRROR}/${_kmname}" )
613 599
614 debug-print "${FUNCNAME}: Repository: ${EGIT_REPO_URI}" 600 debug-print "${FUNCNAME}: Repository: ${EGIT_REPO_URI}"
615 debug-print "${FUNCNAME}: Branch: ${EGIT_BRANCH}" 601 debug-print "${FUNCNAME}: Branch: ${EGIT_BRANCH}"
616 ;; 602 ;;
617 esac 603 esac
618} 604}
619 605
620case ${BUILD_TYPE} in 606case ${KDE_BUILD_TYPE} in
621 live) _calculate_live_repo ;; 607 live) _calculate_live_repo ;;
622 *) _calculate_src_uri ;; 608 *) _calculate_src_uri ;;
623esac 609esac
624 610
625debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}" 611debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
626 612
627# @ECLASS-VARIABLE: PREFIX 613# @ECLASS-VARIABLE: PREFIX
628# @DESCRIPTION: 614# @DESCRIPTION:
629# Set the installation PREFIX for non kde-base applications. It defaults to /usr. 615# Set the installation PREFIX for non kde-base applications. It defaults to /usr.
630# kde-base packages go into KDE4 installation directory (KDEDIR) by default. 616# kde-base packages go into KDE4 installation directory (/usr).
631# No matter the PREFIX, package will be built against KDE installed in KDEDIR. 617# No matter the PREFIX, package will be built against KDE installed in /usr.
632 618
633# @FUNCTION: kde4-base_pkg_setup 619# @FUNCTION: kde4-base_pkg_setup
634# @DESCRIPTION: 620# @DESCRIPTION:
635# Do the basic kdeprefix KDEDIR settings and determine with which kde should 621# Do some basic settings
636# optional applications link
637kde4-base_pkg_setup() { 622kde4-base_pkg_setup() {
638 debug-print-function ${FUNCNAME} "$@" 623 debug-print-function ${FUNCNAME} "$@"
639 624
640 # QA ebuilds 625 if has handbook ${IUSE} || has "+handbook" ${IUSE} && [ "${KDE_HANDBOOK}" != optional ] ; then
641 [[ -z ${KDE_MINIMAL_VALID} ]] && ewarn "QA Notice: ignoring invalid KDE_MINIMAL (defaulting to ${KDE_MINIMAL})." 626 eqawarn "Handbook support is enabled via KDE_HANDBOOK=optional in the ebuild."
627 eqawarn "Please do not just set IUSE=handbook, as this leads to dependency errors."
628 fi
642 629
643 # Don't set KDEHOME during compilation, it will cause access violations 630 # Don't set KDEHOME during compilation, it will cause access violations
644 unset KDEHOME 631 unset KDEHOME
645 632
646 # Check if gcc compiler is fresh enough. 633 # Check if gcc compiler is fresh enough.
647 # In theory should be in pkg_pretend but we check it only for kdelibs there 634 # In theory should be in pkg_pretend but we check it only for kdelibs there
648 # and for others we do just quick scan in pkg_setup because pkg_pretend 635 # and for others we do just quick scan in pkg_setup because pkg_pretend
649 # executions consume quite some time. 636 # executions consume quite some time (ie. when merging 300 packages at once will cause 300 checks)
637 if [[ ${MERGE_TYPE} != binary ]]; then
650 [[ $(gcc-major-version) -lt 4 ]] || \ 638 [[ $(gcc-major-version) -lt 4 ]] || \
651 ( [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -le 3 ]] ) \ 639 ( [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -le 6 ]] ) \
652 && die "Sorry, but gcc-4.3 and earlier wont work for KDE (see bug 354837)." 640 && die "Sorry, but gcc-4.6 and earlier wont work for some KDE packages."
641 fi
653 642
654 if [[ ${KDEBASE} = kde-base ]]; then
655 if use kdeprefix; then
656 KDEDIR=/usr/kde/${SLOT}
657 else
658 KDEDIR=/usr 643 KDEDIR=/usr
659 fi
660 : ${PREFIX:=${KDEDIR}}
661 else
662 # Determine KDEDIR by loooking for the closest match with KDE_MINIMAL
663 KDEDIR=
664 local kde_minimal_met
665 for slot in ${KDE_SLOTS[@]} ${KDE_LIVE_SLOTS[@]}; do
666 [[ -z ${kde_minimal_met} ]] && [[ ${slot} = ${KDE_MINIMAL} ]] && kde_minimal_met=1
667 if [[ -n ${kde_minimal_met} ]] && has_version "kde-base/kdelibs:${slot}"; then
668 if has_version "kde-base/kdelibs:${slot}[kdeprefix]"; then
669 KDEDIR=/usr/kde/${slot}
670 else
671 KDEDIR=/usr
672 fi
673 break;
674 fi
675 done
676 unset slot
677
678 # Bail out if kdelibs required but not found
679 if [[ ${KDE_REQUIRED} = always ]] || { [[ ${KDE_REQUIRED} = optional ]] && use kde; }; then
680 [[ -z ${KDEDIR} ]] && die "Failed to determine KDEDIR!"
681 else
682 [[ -z ${KDEDIR} ]] && KDEDIR=/usr
683 fi
684
685 : ${PREFIX:=/usr} 644 : ${PREFIX:=/usr}
686 fi 645 EKDEDIR=${EPREFIX}/usr
687 EKDEDIR=${EPREFIX}${KDEDIR}
688 646
689 # Point pkg-config path to KDE *.pc files
690 export PKG_CONFIG_PATH="${EKDEDIR}/$(get_libdir)/pkgconfig${PKG_CONFIG_PATH:+:${PKG_CONFIG_PATH}}"
691 # Point to correct QT plugins path 647 # Point to correct QT plugins path
692 QT_PLUGIN_PATH="${EKDEDIR}/$(get_libdir)/kde4/plugins/" 648 QT_PLUGIN_PATH="${EPREFIX}/usr/$(get_libdir)/kde4/plugins/"
693 649
694 # Fix XDG collision with sandbox 650 # Fix XDG collision with sandbox
695 export XDG_CONFIG_HOME="${T}" 651 export XDG_CONFIG_HOME="${T}"
696} 652}
697 653
699# @DESCRIPTION: 655# @DESCRIPTION:
700# This function unpacks the source tarballs for KDE4 applications. 656# This function unpacks the source tarballs for KDE4 applications.
701kde4-base_src_unpack() { 657kde4-base_src_unpack() {
702 debug-print-function ${FUNCNAME} "$@" 658 debug-print-function ${FUNCNAME} "$@"
703 659
704 if [[ ${BUILD_TYPE} = live ]]; then 660 if [[ ${KDE_BUILD_TYPE} = live ]]; then
705 case ${KDE_SCM} in 661 case ${KDE_SCM} in
706 svn) 662 svn)
707 migrate_store_dir
708 subversion_src_unpack 663 subversion_src_unpack
709 ;; 664 ;;
710 git) 665 git)
711 git-2_src_unpack 666 git-r3_src_unpack
712 ;; 667 ;;
713 esac 668 esac
714 else 669 else
715 unpack ${A} 670 unpack ${A}
716 fi 671 fi
733 fi 688 fi
734 689
735 # Enable/disable handbooks for kde4-base packages 690 # Enable/disable handbooks for kde4-base packages
736 # kde-l10n inherits kde4-base but is metpackage, so no check for doc 691 # kde-l10n inherits kde4-base but is metpackage, so no check for doc
737 # kdelibs inherits kde4-base but handle installing the handbook itself 692 # kdelibs inherits kde4-base but handle installing the handbook itself
738 if ! has kde4-meta ${INHERITED} && has handbook ${IUSE//+}; then 693 if ! has kde4-meta ${INHERITED} && in_iuse handbook; then
739 if [[ ${KDEBASE} == kde-base ]]; then 694 if [[ ${KDEBASE} == kde-base ]]; then
740 if [[ ${PN} != kde-l10n && ${PN} != kdepim-l10n && ${PN} != kdelibs ]] && use !handbook; then 695 if [[ ${PN} != kde-l10n && ${PN} != kdepim-l10n && ${PN} != kdelibs ]] && use !handbook; then
741 # documentation in kde4-functions 696 # documentation in kde4-functions
742 : ${KDE_DOC_DIRS:=doc} 697 : ${KDE_DOC_DIRS:=doc}
743 local dir 698 local dir
753 enable_selected_doc_linguas 708 enable_selected_doc_linguas
754 fi 709 fi
755 fi 710 fi
756 711
757 # SCM bootstrap 712 # SCM bootstrap
758 if [[ ${BUILD_TYPE} = live ]]; then 713 if [[ ${KDE_BUILD_TYPE} = live ]]; then
759 case ${KDE_SCM} in 714 case ${KDE_SCM} in
760 svn) subversion_src_prepare ;; 715 svn) subversion_src_prepare ;;
761 esac 716 esac
762 fi 717 fi
763 718
764 # Apply patches 719 # Apply patches, cmake-utils does the job already
765 base_src_prepare 720 cmake-utils_src_prepare
766 721
767 # Save library dependencies 722 # Save library dependencies
768 if [[ -n ${KMSAVELIBS} ]] ; then 723 if [[ -n ${KMSAVELIBS} ]] ; then
769 save_library_dependencies 724 save_library_dependencies
770 fi 725 fi
772 # Inject library dependencies 727 # Inject library dependencies
773 if [[ -n ${KMLOADLIBS} ]] ; then 728 if [[ -n ${KMLOADLIBS} ]] ; then
774 load_library_dependencies 729 load_library_dependencies
775 fi 730 fi
776 731
777 # Replace KDE4Workspace library targets
778 find "${S}" -name CMakeLists.txt \
779 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_TASKMANAGER_(LIBRARY|LIBS)\}/taskmanager/g' {} + \
780 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KWORKSPACE_(LIBRARY|LIBS)\}/kworkspace/g' {} + \
781 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_SOLIDCONTROLIFACES_(LIBRARY|LIBS)\}/solidcontrolifaces/g' {} + \
782 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_SOLIDCONTROL_(LIBRARY|LIBS)\}/solidcontrol/g' {} + \
783 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_PROCESSUI_(LIBRARY|LIBS)\}/processui/g' {} + \
784 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_LSOFUI_(LIBRARY|LIBS)\}/lsofui/g' {} + \
785 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_PLASMACLOCK_(LIBRARY|LIBS)\}/plasmaclock/g' {} + \
786 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_NEPOMUKQUERYCLIENT_(LIBRARY|LIBS)\}/nepomukqueryclient/g' {} + \
787 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_NEPOMUKQUERY_(LIBRARY|LIBS)\}/nepomukquery/g' {} + \
788 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KSCREENSAVER_(LIBRARY|LIBS)\}/kscreensaver/g' {} + \
789 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_WEATHERION_(LIBRARY|LIBS)\}/weather_ion/g' {} + \
790 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KWINEFFECTS_(LIBRARY|LIBS)\}/kwineffects/g' {} + \
791 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KDECORATIONS_(LIBRARY|LIBS)\}/kdecorations/g' {} + \
792 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KSGRD_(LIBRARY|LIBS)\}/ksgrd/g' {} + \
793 -exec sed -i -r -e 's/\$\{KDE4WORKSPACE_KEPHAL_(LIBRARY|LIBS)\}/kephal/g' {} + \
794 || die 'failed to replace KDE4Workspace library targets'
795
796 # Hack for manuals relying on outdated DTD, only outside kde-base/koffice/... 732 # Hack for manuals relying on outdated DTD, only outside kde-base/...
797 if [[ -z ${KDEBASE} ]]; then 733 if [[ -z ${KDEBASE} ]]; then
798 find "${S}" -name "*.docbook" \ 734 find "${S}" -name "*.docbook" \
799 -exec sed -i -r \ 735 -exec sed -i -r \
800 -e 's:-//KDE//DTD DocBook XML V4\.1(\..)?-Based Variant V1\.[01]//EN:-//KDE//DTD DocBook XML V4.2-Based Variant V1.1//EN:g' {} + \ 736 -e 's:-//KDE//DTD DocBook XML V4\.1(\..)?-Based Variant V1\.[01]//EN:-//KDE//DTD DocBook XML V4.2-Based Variant V1.1//EN:g' {} + \
801 || die 'failed to fix DocBook variant version' 737 || die 'failed to fix DocBook variant version'
809 debug-print-function ${FUNCNAME} "$@" 745 debug-print-function ${FUNCNAME} "$@"
810 746
811 # Build tests in src_test only, where we override this value 747 # Build tests in src_test only, where we override this value
812 local cmakeargs=(-DKDE4_BUILD_TESTS=OFF) 748 local cmakeargs=(-DKDE4_BUILD_TESTS=OFF)
813 749
814 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then 750 if use_if_iuse debug; then
815 cmakeargs+=(-DKDE4_ENABLE_FINAL=ON)
816 fi
817
818 if has debug ${IUSE//+} && use debug; then
819 # Set "real" debug mode 751 # Set "real" debug mode
820 CMAKE_BUILD_TYPE="Debugfull" 752 CMAKE_KDE_BUILD_TYPE="Debugfull"
821 else 753 else
822 # Handle common release builds 754 # Handle common release builds
823 append-cppflags -DQT_NO_DEBUG 755 append-cppflags -DQT_NO_DEBUG
824 fi 756 fi
825 757
830 tc-is-cross-compiler || cmakeargs+=(-DCMAKE_INSTALL_PREFIX="${EPREFIX}${PREFIX}") 762 tc-is-cross-compiler || cmakeargs+=(-DCMAKE_INSTALL_PREFIX="${EPREFIX}${PREFIX}")
831 763
832 # Use colors 764 # Use colors
833 QTEST_COLORED=1 765 QTEST_COLORED=1
834 766
835 # Shadow existing /usr installations 767 # Shadow existing installations
836 unset KDEDIRS 768 unset KDEDIRS
837 769
838 # Handle kdeprefix-ed KDE
839 if [[ ${KDEDIR} != /usr ]]; then
840 # Override some environment variables - only when kdeprefix is different,
841 # to not break ccache/distcc
842 PATH="${EKDEDIR}/bin:${PATH}"
843
844 # Append library search path
845 append-ldflags -L"${EKDEDIR}/$(get_libdir)"
846
847 # Append full RPATH
848 cmakeargs+=(-DCMAKE_SKIP_RPATH=OFF)
849
850 # Set cmake prefixes to allow buildsystem to locate valid KDE installation
851 # when more are present
852 cmakeargs+=(-DCMAKE_SYSTEM_PREFIX_PATH="${EKDEDIR}")
853 fi
854
855 #qmake -query QT_INSTALL_LIBS unavailable when cross-compiling 770 #qmake -query QT_INSTALL_LIBS unavailable when cross-compiling
856 tc-is-cross-compiler && cmakeargs+=(-DQT_LIBRARY_DIR=${ROOT}/usr/lib/qt4) 771 tc-is-cross-compiler && cmakeargs+=(-DQT_LIBRARY_DIR=${ROOT}/usr/$(get_libdir)/qt4)
857 #kde-config -path data unavailable when cross-compiling 772 #kde-config -path data unavailable when cross-compiling
858 tc-is-cross-compiler && cmakeargs+=(-DKDE4_DATA_DIR=${ROOT}/usr/share/apps/) 773 tc-is-cross-compiler && cmakeargs+=(-DKDE4_DATA_DIR=${ROOT}/usr/share/apps/)
859 774
860 # Handle kdeprefix in application itself
861 if ! has kdeprefix ${IUSE//+} || ! use kdeprefix; then
862 # If prefix is /usr, sysconf needs to be /etc, not /usr/etc 775 # sysconf needs to be /etc, not /usr/etc
863 cmakeargs+=(-DSYSCONF_INSTALL_DIR="${EPREFIX}"/etc) 776 cmakeargs+=(-DSYSCONF_INSTALL_DIR="${EPREFIX}"/etc)
864 fi
865 777
866 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then 778 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
779 if [[ ${mycmakeargs} ]]; then
780 eqawarn "mycmakeargs should always be declared as an array, not a string"
781 fi
867 mycmakeargs=(${mycmakeargs}) 782 mycmakeargs=(${mycmakeargs})
868 fi 783 fi
869 784
870 mycmakeargs=("${cmakeargs[@]}" "${mycmakeargs[@]}") 785 mycmakeargs=("${cmakeargs[@]}" "${mycmakeargs[@]}")
871 786
884# @FUNCTION: kde4-base_src_test 799# @FUNCTION: kde4-base_src_test
885# @DESCRIPTION: 800# @DESCRIPTION:
886# Function for testing KDE4 applications. 801# Function for testing KDE4 applications.
887kde4-base_src_test() { 802kde4-base_src_test() {
888 debug-print-function ${FUNCNAME} "$@" 803 debug-print-function ${FUNCNAME} "$@"
804
805 local kded4_pid
806
807 _test_runner() {
808 if [[ -n "${VIRTUALDBUS_TEST}" ]]; then
809 export $(dbus-launch)
810 kded4 2>&1 > /dev/null &
811 kded4_pid=$!
812 fi
813
814 cmake-utils_src_test
815 }
816
817 # When run as normal user during ebuild development with the ebuild command, the
818 # kde tests tend to access the session DBUS. This however is not possible in a real
819 # emerge or on the tinderbox.
820 # > make sure it does not happen, so bad tests can be recognized and disabled
821 unset DBUS_SESSION_BUS_ADDRESS DBUS_SESSION_BUS_PID
889 822
890 # Override this value, set in kde4-base_src_configure() 823 # Override this value, set in kde4-base_src_configure()
891 mycmakeargs+=(-DKDE4_BUILD_TESTS=ON) 824 mycmakeargs+=(-DKDE4_BUILD_TESTS=ON)
892 cmake-utils_src_configure 825 cmake-utils_src_configure
893 kde4-base_src_compile 826 kde4-base_src_compile
894
895 # When run as normal user during ebuild development with the ebuild command, the
896 # kde tests tend to access the session DBUS. This however is not possible in a real
897 # emerge or on the tinderbox.
898 # > make sure it does not happen, so bad tests can be recognized and disabled
899 unset DBUS_SESSION_BUS_ADDRESS
900 827
901 if [[ ${VIRTUALX_REQUIRED} == always || ${VIRTUALX_REQUIRED} == test ]]; then 828 if [[ ${VIRTUALX_REQUIRED} == always || ${VIRTUALX_REQUIRED} == test ]]; then
902 # check for sanity if anyone already redefined VIRTUALX_COMMAND from the default 829 # check for sanity if anyone already redefined VIRTUALX_COMMAND from the default
903 if [[ ${VIRTUALX_COMMAND} != emake ]]; then 830 if [[ ${VIRTUALX_COMMAND} != emake ]]; then
904 # surprise- we are already INSIDE virtualmake!!! 831 # surprise- we are already INSIDE virtualmake!!!
905 debug-print "QA Notice: This version of kde4-base.eclass includes the virtualx functionality." 832 debug-print "QA Notice: This version of kde4-base.eclass includes the virtualx functionality."
906 debug-print " You may NOT set VIRTUALX_COMMAND or call virtualmake from the ebuild." 833 debug-print " You may NOT set VIRTUALX_COMMAND or call virtualmake from the ebuild."
907 debug-print " Setting VIRTUALX_REQUIRED is completely sufficient. See the" 834 debug-print " Setting VIRTUALX_REQUIRED is completely sufficient. See the"
908 debug-print " kde4-base.eclass docs for details... Applying workaround." 835 debug-print " kde4-base.eclass docs for details... Applying workaround."
909 cmake-utils_src_test 836 _test_runner
910 else 837 else
911 VIRTUALX_COMMAND="cmake-utils_src_test" virtualmake 838 VIRTUALX_COMMAND="_test_runner" virtualmake
912 fi 839 fi
913 else 840 else
914 cmake-utils_src_test 841 _test_runner
842 fi
843
844 if [ -n "${kded4_pid}" ] ; then
845 kill ${kded4_pid}
846 fi
847
848 if [ -n "${DBUS_SESSION_BUS_PID}" ] ; then
849 kill ${DBUS_SESSION_BUS_PID}
915 fi 850 fi
916} 851}
917 852
918# @FUNCTION: kde4-base_src_install 853# @FUNCTION: kde4-base_src_install
919# @DESCRIPTION: 854# @DESCRIPTION:
936 done 871 done
937 fi 872 fi
938 873
939 cmake-utils_src_install 874 cmake-utils_src_install
940 875
941 # In EAPI 4+, we don't want ${PREFIX}/share/doc/HTML to be compressed, 876 # We don't want ${PREFIX}/share/doc/HTML to be compressed,
942 # because then khelpcenter can't find the docs 877 # because then khelpcenter can't find the docs
943 [[ ${EAPI:-0} != 3 && -d ${ED}/${PREFIX}/share/doc/HTML ]] && 878 [[ -d ${ED}/${PREFIX}/share/doc/HTML ]] &&
944 docompress -x ${PREFIX}/share/doc/HTML 879 docompress -x ${PREFIX}/share/doc/HTML
945} 880}
946 881
947# @FUNCTION: kde4-base_pkg_preinst 882# @FUNCTION: kde4-base_pkg_preinst
948# @DESCRIPTION: 883# @DESCRIPTION:
949# Function storing icon caches 884# Function storing icon caches
950kde4-base_pkg_preinst() { 885kde4-base_pkg_preinst() {
951 debug-print-function ${FUNCNAME} "$@" 886 debug-print-function ${FUNCNAME} "$@"
952 887
953 gnome2_icon_savelist 888 gnome2_icon_savelist
889 if [[ ${KDE_BUILD_TYPE} == live && ${KDE_SCM} == svn ]]; then
890 subversion_pkg_preinst
891 fi
954} 892}
955 893
956# @FUNCTION: kde4-base_pkg_postinst 894# @FUNCTION: kde4-base_pkg_postinst
957# @DESCRIPTION: 895# @DESCRIPTION:
958# Function to rebuild the KDE System Configuration Cache after an application has been installed. 896# Function to rebuild the KDE System Configuration Cache after an application has been installed.
963 fdo-mime_desktop_database_update 901 fdo-mime_desktop_database_update
964 fdo-mime_mime_database_update 902 fdo-mime_mime_database_update
965 buildsycoca 903 buildsycoca
966 904
967 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then 905 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
968 if has kdeenablefinal ${IUSE//+} && use kdeenablefinal; then
969 echo
970 ewarn "WARNING! you have kdeenable final useflag enabled."
971 ewarn "This useflag needs to be enabled on ALL kde using packages and"
972 ewarn "is known to cause issues."
973 ewarn "You are using this setup at your own risk and the kde team does not"
974 ewarn "take responsibilities for dead kittens."
975 echo
976 fi
977 if [[ ${BUILD_TYPE} = live ]]; then 906 if [[ ${KDE_BUILD_TYPE} = live ]]; then
978 echo 907 echo
979 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}" 908 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}"
980 einfo "Use it at your own risk." 909 einfo "Use it at your own risk."
981 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!" 910 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!"
982 echo 911 echo
983 fi 912 fi
984 # for all 3rd party soft tell user that he SHOULD install kdebase-startkde or kdebase-runtime-meta 913 # for all 3rd party soft tell user that he SHOULD install kdebase-startkde or kdebase-runtime-meta
985 if [[ ${KDEBASE} != kde-base ]] && \ 914 if [[ ${KDEBASE} != kde-base ]] && \
986 ! has_version 'kde-base/kdebase-runtime-meta' && \ 915 ! has_version 'kde-apps/kdebase-runtime-meta' && \
987 ! has_version 'kde-base/kdebase-startkde'; then 916 ! has_version 'kde-base/kdebase-startkde'; then
988 if [[ ${KDE_REQUIRED} == always ]] || ( [[ ${KDE_REQUIRED} == optional ]] && use kde ); then 917 if [[ ${KDE_REQUIRED} == always ]] || ( [[ ${KDE_REQUIRED} == optional ]] && use kde ); then
989 echo 918 echo
990 ewarn "WARNING! Your system configuration contains neither \"kde-base/kdebase-runtime-meta\"" 919 ewarn "WARNING! Your system configuration contains neither \"kde-base/kdebase-runtime-meta\""
991 ewarn "nor \"kde-base/kdebase-startkde\". You need one of above." 920 ewarn "nor \"kde-base/kdebase-startkde\". You need one of above."
992 ewarn "With this setting you are unsupported by KDE team." 921 ewarn "With this setting you are unsupported by KDE team."
993 ewarn "All missing features you report for misc packages will be probably ignored or closed as INVALID." 922 ewarn "All missing features you report for misc packages will be probably ignored or closed as INVALID."
994 fi 923 fi
995 fi 924 fi
996 fi 925 fi
997 if has kdeprefix ${IUSE//+} && use kdeprefix; then
998 # warning about kdeprefix
999 echo
1000 ewarn "WARNING! You have the kdeprefix useflag enabled."
1001 eerror "This setting will be removed on or about 2011-06-06."
1002 ewarn "You are using this setup at your own risk and the kde team does not"
1003 ewarn "take responsibilities for dead kittens."
1004 echo
1005 fi
1006} 926}
1007 927
1008# @FUNCTION: kde4-base_pkg_postrm 928# @FUNCTION: kde4-base_pkg_postrm
1009# @DESCRIPTION: 929# @DESCRIPTION:
1010# Function to rebuild the KDE System Configuration Cache after an application has been removed. 930# Function to rebuild the KDE System Configuration Cache after an application has been removed.
1014 gnome2_icon_cache_update 934 gnome2_icon_cache_update
1015 fdo-mime_desktop_database_update 935 fdo-mime_desktop_database_update
1016 fdo-mime_mime_database_update 936 fdo-mime_mime_database_update
1017 buildsycoca 937 buildsycoca
1018} 938}
939
940fi

Legend:
Removed from v.1.93  
changed lines
  Added in v.1.157

  ViewVC Help
Powered by ViewVC 1.1.20